#include <iostream>
#include <fstream>
#include <cstring>
#include <cctype>

const int MAX_FILENAME_LENGTH = 256;
const int MAX_INPUT_STRING_LENGTH = 256;

bool isValidFilename(const char* filename) {
    //    
    const char* forbiddenChars = "*\"<>?|";
    if (strpbrk(filename, forbiddenChars) != nullptr) {
        return false;
    }

    //   
    const char* colonPosition = strchr(filename, ':');
    if (colonPosition != nullptr) {
        if (colonPosition == filename + 1 && isalpha(filename[0])) {
            //     
            const char* backslashPosition = strchr(colonPosition + 1, '\\');
            if (backslashPosition == nullptr) {
                return false;
            }
        } else {
            return false;
        }
    }

    //   
    const char* extension = strrchr(filename, '.');
    if (extension != nullptr) {
        if (strcmp(extension, ".txt") != 0 && strcmp(extension, ".TXT") != 0) {
            return false;
        }
    }

    return true;
}

int main() {
    //   
    char filename[MAX_FILENAME_LENGTH];
    std::cout << "  : ";
    std::cin.getline(filename, MAX_FILENAME_LENGTH);

    //    
    if (!isValidFilename(filename)) {
        std::cerr << "  .\n";
        return 1;
    }

    //   .txt,   
    if (strrchr(filename, '.') == nullptr) {
        strcat(filename, ".txt");
    }

    //  
    std::ifstream file(filename, std::ios::binary);
    if (!file.is_open()) {
        std::cerr << "  .\n";
        return 1;
    }

    //   
    file.seekg(0, std::ios::end);
    std::streampos fileSize = file.tellg();
    file.seekg(0, std::ios::beg);

    //     
    char* fileContent = new char[fileSize];

    //     
    file.read(fileContent, fileSize);
    file.close();

    //    
    char inputString[MAX_INPUT_STRING_LENGTH];
    std::cout << "   : ";
    std::cin.getline(inputString, MAX_INPUT_STRING_LENGTH);

    //     
    int occurrences = 0;
    char* position = fileContent;
    while ((position = strstr(position, inputString)) != nullptr) {
        occurrences++;
        position += strlen(inputString);
    }

    //  
    std::cout << "    : " << occurrences << std::endl;

    //   
    delete[] fileContent;

    return 0;
}
